/*  SWIG interface code generated by apiwrapper for GAMS Version 33.2.0
 *
 * GAMS - Loading mechanism for GAMS Expert-Level APIs
 *
 * Copyright (c) 2016-2020 GAMS Software GmbH <support@gams.com>
 * Copyright (c) 2016-2020 GAMS Development Corp. <support@gams.com>
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */
%module(moduleimport="import $module") optcc
%include cpointer.i
%include typemaps.i
%include carrays.i
%include cstring.i

%{
/* Put header files here or function declarations like below */
#define SWIG_FILE_WITH_INIT
#include "optcc.h"
#include "gclgms.h"
#define optHandleToPtr
#define ptrTooptHandle
%}



enum optDataType {
  optDataNone    = 0,
  optDataInteger = 1,
  optDataDouble  = 2,
  optDataString  = 3,
  optDataStrList = 4  };

enum optOptionType {
  optTypeInteger   = 0,
  optTypeDouble    = 1,
  optTypeString    = 2,
  optTypeBoolean   = 3,
  optTypeEnumStr   = 4,
  optTypeEnumInt   = 5,
  optTypeMultiList = 6,
  optTypeStrList   = 7,
  optTypeMacro     = 8,
  optTypeImmediate = 9  };

enum optOptionSubType {
  optsubRequired = 0,
  optsubNoValue  = 1,
  optsubOptional = 2,
  optsub2Values  = 3  };

enum optMsgType {
  optMsgInputEcho    = 0,
  optMsgHelp         = 1,
  optMsgDefineError  = 2,
  optMsgValueError   = 3,
  optMsgValueWarning = 4,
  optMsgDeprecated   = 5,
  optMsgFileEnter    = 6,
  optMsgFileLeave    = 7,
  optMsgTooManyMsgs  = 8,
  optMsgUserError    = 9  };

enum optVarEquMapType {
  optMapIndicator  = 0,
  optMapDefinedVar = 1  };

%array_class(int, intArray);
%array_class(double, doubleArray);
%pointer_functions(int, intp);
%pointer_functions(double, doublep);
%pointer_functions(optHandle_t, optHandle_tp);

%typemap(in) void *{
    int res = SWIG_ConvertPtr($input,SWIG_as_voidptrptr(&$1), SWIGTYPE_p_void, 0);
    if (!SWIG_IsOK(res)) {
    SWIG_exception_fail(SWIG_ArgError(res), "in method '" "$symname" "', argument " " of type '" "void *""'");
  }
}

%typemap(in) void **{
    void *$1__p;
    int res = SWIG_ConvertPtr($input,SWIG_as_voidptrptr(&$1__p), SWIGTYPE_p_void, 0);
    if (!SWIG_IsOK(res)) {
    SWIG_exception_fail(SWIG_ArgError(res), "in method '" "$symname" "', argument " " of type '" "void *""'");
    }
    $1 = &$1__p;
}

%typemap(out) optHandle_t {
  resultobj = SWIG_NewPointerObj((optHandle_t *)memcpy((optHandle_t *)malloc(sizeof(optHandle_t)),&result,sizeof(optHandle_t)), SWIGTYPE_p_optHandle_t, 0 |  0 );
}

%typemap(in) TArgvCB_t{
    if ($input == Py_None)
      $1 = NULL;
    else
    {
      void *argp;
      int ret = SWIG_ConvertPtr($input, &argp, SWIGTYPE_p_TArgvCB_t,  0 );
      if (!SWIG_IsOK(ret)) {
        SWIG_exception_fail(SWIG_ArgError(ret), "in method '" "$symname" "', argument " " of type '" "TArgvCB_t""'");
      }
      if (!argp) {
        SWIG_exception_fail(SWIG_ValueError, "invalid null reference " "in method '" "$symname" "', argument of type '" "TArgvCB_t""'");
      } else {
        $1 = *((TArgvCB_t *)(argp));
      }
    }
}
%pointer_functions(TArgvCB_t, TArgvCB_tp);
%typemap(in, numinputs=0) char *_oss_buf() {
  $1 = (char *) malloc(sizeof(char) * (GMS_SSSIZE+1));
}

%typemap(freearg) char *_oss_buf() {
  free((char *) $1);
}


%cstring_bounded_output(char *msgBuf_out, GMS_SSSIZE);
%cstring_bounded_output(char *result_out, GMS_SSSIZE);
%cstring_bounded_output(char *info_out, GMS_SSSIZE);
%cstring_bounded_output(char *AName_out, GMS_SSSIZE);
%cstring_bounded_output(char *ASName_out, GMS_SSSIZE);
%cstring_bounded_output(char *ASVal_out, GMS_SSSIZE);
%cstring_bounded_output(char *sversion_out, GMS_SSSIZE);
%cstring_bounded_output(char *sfilename_out, GMS_SSSIZE);
%cstring_bounded_output(char *skey_out, GMS_SSSIZE);
%cstring_bounded_output(char *sval_out, GMS_SSSIZE);
%cstring_bounded_output(char *SSyn_out, GMS_SSSIZE);
%cstring_bounded_output(char *SName_out, GMS_SSSIZE);
%cstring_bounded_output(char *EOLChars_out, GMS_SSSIZE);
%cstring_bounded_output(char *AHelpStr_out, GMS_SSSIZE);
%cstring_bounded_output(char *AValStr_out, GMS_SSSIZE);
%cstring_bounded_output(char *ASOpt_out, GMS_SSSIZE);
%cstring_bounded_output(char *ASHelp_out, GMS_SSSIZE);
%cstring_bounded_output(char *AHelp_out, GMS_SSSIZE);
%cstring_bounded_output(char *VEName_out, GMS_SSSIZE);
%cstring_bounded_output(char *AUEL_out, GMS_SSSIZE);
%cstring_bounded_output(char *EquName_out, GMS_SSSIZE);
%cstring_bounded_output(char *VarName_out, GMS_SSSIZE);
%cstring_bounded_output(char *AIndex_out, GMS_SSSIZE);
%cstring_bounded_output(char *cname_out, GMS_SSSIZE);
%cstring_bounded_output(char *sTName_out, GMS_SSSIZE);
%cstring_bounded_output(char *solver_out, GMS_SSSIZE);
%cstring_mutable(char *p_mut, GMS_SSSIZE);

%feature("autodoc", "0");

extern void *optHandleToPtr (optHandle_t popt);
extern optHandle_t ptrTooptHandle (void *vptr);
extern int optGetReady (char *msgBuf_out, int msgBufSize);
extern int optGetReadyD (const char *dirName, char *msgBuf_out, int msgBufSize);
extern int optGetReadyL (const char *libName, char *msgBuf_out, int msgBufSize);
extern int optCreate (optHandle_t *popt, char *msgBuf_out, int msgBufSize);
extern int optCreateD (optHandle_t *popt, const char *dirName, char *msgBuf_out, int msgBufSize);
extern int optCreateL (optHandle_t *popt, const char *libName, char *msgBuf_out, int msgBufSize);
extern int optFree (optHandle_t *popt);
extern int optLibraryLoaded(void);
extern int optLibraryUnload(void);
extern int optGetScreenIndicator(void);
extern void optSetScreenIndicator(int scrind);
extern int optGetExceptionIndicator(void);
extern void optSetExceptionIndicator(int excind);
extern int optGetExitIndicator(void);
extern void optSetExitIndicator(int extind);
extern optErrorCallback_t optGetErrorCallback(void);
extern void optSetErrorCallback(optErrorCallback_t func);
extern int optGetAPIErrorCount(void);
extern void optSetAPIErrorCount(int ecnt);
extern void optErrorHandling(const char *msg);
extern int  optReadDefinition (optHandle_t popt, const char *fn);
extern int  optReadDefinitionFromPChar (optHandle_t popt, char *p_mut);
extern int  optReadParameterFile (optHandle_t popt, const char *fn);
extern void  optReadFromStr (optHandle_t popt, const char *s);
extern int  optWriteParameterFile (optHandle_t popt, const char *fn);
extern void  optClearMessages (optHandle_t popt);
extern void  optAddMessage (optHandle_t popt, const char *info);
extern void  optGetMessage (optHandle_t popt, int NrMsg, char *info_out, int *OUTPUT);
extern void  optResetAll (optHandle_t popt);
extern void  optResetAllRecent (optHandle_t popt);
extern void  optResetRecentChanges (optHandle_t popt);
extern void  optShowHelp (optHandle_t popt, const char *AHlpID);
extern int  optResetNr (optHandle_t popt, int ANr);
extern int  optFindStr (optHandle_t popt, const char *AName, int *OUTPUT, int *OUTPUT);
extern int  optGetInfoNr (optHandle_t popt, int ANr, int *OUTPUT, int *OUTPUT, int *OUTPUT, int *OUTPUT, int *OUTPUT, int *OUTPUT);
extern int  optGetValuesNr (optHandle_t popt, int ANr, char *ASName_out, int *OUTPUT, double *OUTPUT, char *ASVal_out);
extern int  optSetValuesNr (optHandle_t popt, int ANr, int AIVal, double ADVal, const char *ASVal);
extern int  optSetValues2Nr (optHandle_t popt, int ANr, int AIVal, double ADVal, const char *ASVal);
extern void  optVersion (optHandle_t popt, char *sversion_out);
extern void  optDefinitionFile (optHandle_t popt, char *sfilename_out);
extern int  optGetFromAnyStrList (optHandle_t popt, int idash, char *skey_out, char *sval_out);
extern int  optGetFromListStr (optHandle_t popt, const char *skey, char *sval_out);
extern int  optListCountStr (optHandle_t popt, const char *skey);
extern int  optReadFromListStr (optHandle_t popt, const char *skey, int iPos, char *sval_out);
extern int  optSynonymCount (optHandle_t popt);
extern int  optGetSynonym (optHandle_t popt, int NrSyn, char *SSyn_out, char *SName_out);
extern void  optEchoSet (optHandle_t popt, int AIVal);
extern int  optEOLOnlySet (optHandle_t popt, int AIVal);
extern void  optNoBoundsSet (optHandle_t popt, int AIVal);
extern int  optEOLChars (optHandle_t popt, char *EOLChars_out);
extern void  optErrorCount (optHandle_t popt, int *OUTPUT, int *OUTPUT);
extern int  optGetBoundsInt (optHandle_t popt, int ANr, int *OUTPUT, int *OUTPUT, int *OUTPUT);
extern int  optGetBoundsDbl (optHandle_t popt, int ANr, double *OUTPUT, double *OUTPUT, double *OUTPUT);
extern int  optGetDefaultStr (optHandle_t popt, int ANr, char *sval_out);
extern int  optGetIntNr (optHandle_t popt, int ANr, int *OUTPUT);
extern int  optGetInt2Nr (optHandle_t popt, int ANr, int *OUTPUT);
extern int  optSetIntNr (optHandle_t popt, int ANr, int AIVal);
extern int  optSetInt2Nr (optHandle_t popt, int ANr, int AIVal);
extern int  optGetStrNr (optHandle_t popt, int ANr, char *ASVal_out);
extern int  optGetOptHelpNr (optHandle_t popt, int ANr, char *AName_out, int *OUTPUT, int *OUTPUT);
extern int  optGetEnumHelp (optHandle_t popt, int ANr, int AOrd, int *OUTPUT, char *AHelpStr_out);
extern int  optGetEnumStrNr (optHandle_t popt, int ANr, char *ASVal_out, int *OUTPUT);
extern int  optGetEnumCount (optHandle_t popt, int ANr, int *OUTPUT);
extern int  optGetEnumValue (optHandle_t popt, int ANr, int AOrd, int *OUTPUT, char *AValStr_out);
extern int  optGetStr2Nr (optHandle_t popt, int ANr, char *ASVal_out);
extern int  optSetStrNr (optHandle_t popt, int ANr, const char *ASVal);
extern int  optSetStr2Nr (optHandle_t popt, int ANr, const char *ASVal);
extern int  optGetDblNr (optHandle_t popt, int ANr, double *OUTPUT);
extern int  optGetDbl2Nr (optHandle_t popt, int ANr, double *OUTPUT);
extern int  optSetDblNr (optHandle_t popt, int ANr, double ADVal);
extern int  optSetDbl2Nr (optHandle_t popt, int ANr, double ADVal);
extern int  optGetValStr (optHandle_t popt, const char *AName, char *ASVal_out);
extern int  optGetVal2Str (optHandle_t popt, const char *AName, char *ASVal_out);
extern int  optGetNameNr (optHandle_t popt, int ANr, char *ASName_out);
extern int  optGetDefinedNr (optHandle_t popt, int ANr, int *OUTPUT);
extern int  optGetHelpNr (optHandle_t popt, int ANr, char *ASOpt_out, char *ASHelp_out);
extern int  optGetGroupNr (optHandle_t popt, int ANr, char *AName_out, int *OUTPUT, int *OUTPUT, char *AHelp_out);
extern int  optGetGroupGrpNr (optHandle_t popt, int AGroup);
extern int  optGetOptGroupNr (optHandle_t popt, int ANr);
extern int  optGetDotOptNr (optHandle_t popt, int ANr, char *VEName_out, int *OUTPUT, int *OUTPUT, double *OUTPUT);
extern int  optGetDotOptUel (optHandle_t popt, int ANr, int ADim, char *AUEL_out);
extern int  optGetVarEquMapNr (optHandle_t popt, int maptype, int ANr, char *EquName_out, char *VarName_out, int *OUTPUT, int *OUTPUT, int *OUTPUT);
extern int  optGetEquVarEquMapNr (optHandle_t popt, int maptype, int ANr, int ADim, char *AIndex_out);
extern int  optGetVarVarEquMapNr (optHandle_t popt, int maptype, int ANr, int ADim, char *AIndex_out);
extern int  optVarEquMapCount (optHandle_t popt, int maptype, int *OUTPUT);
extern int  optGetIndicatorNr (optHandle_t popt, int ANr, char *EquName_out, char *VarName_out, int *OUTPUT, int *OUTPUT, int *OUTPUT);
extern int  optGetEquIndicatorNr (optHandle_t popt, int ANr, int ADim, char *AIndex_out);
extern int  optGetVarIndicatorNr (optHandle_t popt, int ANr, int ADim, char *AIndex_out);
extern int  optIndicatorCount (optHandle_t popt, int *OUTPUT);
extern int  optDotOptCount (optHandle_t popt, int *OUTPUT);
extern int  optSetRefNr (optHandle_t popt, int ANr, int ARefNr);
extern int  optSetRefNrStr (optHandle_t popt, const char *AOpt, int ARefNr);
extern int  optGetConstName (optHandle_t popt, int cgroup, int cindex, char *cname_out);
extern int  optGetTypeName (optHandle_t popt, int TNr, char *sTName_out);
extern int  optLookUp (optHandle_t popt, const char *AOpt);
extern void  optReadFromPChar (optHandle_t popt, char *p_mut);
extern void  optReadFromCmdLine (optHandle_t popt, char *p_mut);
extern void  optReadFromCmdArgs (optHandle_t popt, TArgvCB_t cb);
extern int  optGetNameOpt (optHandle_t popt, const char *ASVal, char *solver_out, int *OUTPUT);
extern int  optResetStr (optHandle_t popt, const char *AName);
extern int  optGetDefinedStr (optHandle_t popt, const char *AName);
extern int  optGetIntStr (optHandle_t popt, const char *AName);
extern double  optGetDblStr (optHandle_t popt, const char *AName);
extern char * optGetStrStr (optHandle_t popt, const char *AName, char *_oss_buf);
extern void  optSetIntStr (optHandle_t popt, const char *AName, int AIVal);
extern void  optSetDblStr (optHandle_t popt, const char *AName, double ADVal);
extern void  optSetStrStr (optHandle_t popt, const char *AName, const char *ASVal);
extern int  optIsDeprecated (optHandle_t popt, const char *AName);
extern int  optCount (optHandle_t popt);
extern int  optMessageCount (optHandle_t popt);
extern int  optGroupCount (optHandle_t popt);
extern int  optRecentEnabled (optHandle_t popt);
extern void optRecentEnabledSet (optHandle_t popt, const int x);
extern char * optSeparator (optHandle_t popt, char *_oss_buf);
extern char * optStringQuote (optHandle_t popt, char *_oss_buf);

%include "gclgms_swig.h"
